/*
	Klasse som glatter ut kanter p 
	terrenget for  
	gi et penere utseende
*/
public class Smoothing
{
	HeightField hf;
	
	//Konstruktr
	public Smoothing(HeightField h)
	{
		hf = h;
	}

	public void smooth(float k)
	{
		//k = verdi mellom 0 og 1.0, jo lavere verdi
		//jo mer glatt og flatt blir terrenget
		
		/* Rows, left to right */
	for(int y = 0;y < hf.getSize()-1; y++)
	    for (int x = 1;x < hf.getSize()-1; x++)
		hf.setHeight(x,y,(hf.getHeight(x-1,y) * (1-k) + 
			      hf.getHeight(x,y) * k));

	/* Rows, right to left*/					
		for(int y = hf.getSize()-2;y < -1 ; y--)
	    for (int x = 0;x < hf.getSize()-1; x++)
		hf.setHeight(x,y,(hf.getHeight(x+1,y) * (1-k) + 
			      hf.getHeight(x,y) * k));

	/* Columns, bottom to top */
	for(int x = 1;x < hf.getSize()-1; x++)
	    for (int y = 0;y < hf.getSize()-1; y++)
		hf.setHeight(x,y,(hf.getHeight(x-1,y) * (1-k) + 
			      hf.getHeight(x,y) * k));

	/* Columns, top to bottom */
	for(int x = hf.getSize()-2;x < -1 ; x--)
	    for (int y = 0;y < hf.getSize()-1; y++)
		hf.setHeight(x,y,(hf.getHeight(x+1,y) * (1-k) + 
			      hf.getHeight(x,y) * k));

	}

}

